package nl.github.demo.documentation.model;

import com.fasterxml.jackson.annotation.JsonProperty;
import lombok.val;

public record PipelineSchedule(
        @JsonProperty("description") String name,
        @JsonProperty("ref") String targetBranch,
        Cron cron,
        boolean active
) {

    public PipelineSchedule {
        name = name.strip();

        if (targetBranch.startsWith("refs/heads/")) {
            targetBranch = targetBranch.substring(11);
        }
    }

    public boolean runsOn(final SprintDay day) {
        for (val dayPart : cron.weekDays()) {
            if (dayPart.matches(day)) {
                return true;
            }
        }
        return false;
    }
}
